<!--
“Copyright 2020 L'esfera”

This file is part of L'esfera.

L'esfera is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
-->

<template>
 <div>
    <CommentEditor  :current_node_name="current_node.name"
                    :right_node="node_for_comment"
                    @updateComment="update_comment" />
    <LinkSearch
        :existingLinks="links"
        @addLink="addLink"
    />
    <b-table small 
        :items="links" :fields="fields"
        :sort-by.sync="sortBy"
        :sort-desc.sync="sortDesc"
        thead-class="hidden_header"
        responsive="sm">

        <template #cell(name)="data">
            <router-link    class="nav-link"
                            style="padding:0"
                            :title="data.item.description"
                            :to="{name:'Node', params:{ node_id:data.item.id }}">
                {{ data.item.name }}
            </router-link>
        </template>
        <template #cell(value)="data">
            <span @click="display_comment(data.item.id)" >
                <BIconChatDotsFill aria-hidden="true"
                    v-b-tooltip.hover :title="data.item.comment"
                    v-bind:class="comment_class(data.item.comment)"
                    style=" cursor:pointer;
                            width: 24px;
                            height: 24px;
                            margin: 0 0.4em 0 0; "/>
            </span>
            <span @click="increment_value(data.item.id, data.item.value)" >
                <b-badge
                    pill
                    class="up_pill"
                    v-bind:class="pill_isActive(data.item.id, data.item.value)"
                    >
                    <BIconChevronUp aria-hidden="true" />
                    {{ data.item.value }}
                </b-badge>
            </span>
        </template>
        
    </b-table>

 </div>
</template>

<script>
import axios from 'axios';
import { BIconChevronUp, BIconChatDotsFill } from 'bootstrap-vue'
import LinkSearch from './link-search/LinkSearch.vue'
import CommentEditor from './comment-editor/CommentEditor.vue'

export default {
    name: 'LinkList',
    components: {
        BIconChevronUp,
        BIconChatDotsFill,
        LinkSearch,
        CommentEditor,
    },
    props: { current_node: {} },
    data() {
        return {
            sortBy: 'value',
            sortDesc: true,
            fields: ['name', 'value'],
            links: [],
            node_for_comment: {},
        }
    },
    watch: {
        current_node: function () {
            this.links = this.current_node.related
        }
    },
    computed: {

    },
    methods: {
        display_comment: function (related_node_id) {
            var show_editor = false
            this.links.some(item => {
                if (item.id == related_node_id) {
                    this.node_for_comment = item
                    show_editor = true
                    return true
                }
            });
            if (show_editor) {
                this.$root.$emit('bv::show::modal', 'comment-editor')
            }
        },
        increment_value: function (right_node_id, old_value) {
            if (old_value < this.links.length) {
                this.addLink(right_node_id)
            }
        },
        addLink: function (right_node_id) {
            axios.post(process.env.VUE_APP_API_SERVER + '/relationships', {
                left_node_id: this.current_node.id,
                right_node_id: right_node_id
            })
            .then(response => (
                //console.log(response.data.related_nodes),
                this.links = response.data.related_nodes
            ))
            .catch(function (error) {
                console.log(error);
            });
        },
        update_comment: function (right_node_id, new_comment) {
            axios.post(process.env.VUE_APP_API_SERVER + '/comments', {
                left_node_id: this.current_node.id,
                right_node_id: right_node_id,
                comment: new_comment,
            })
            .then(response => (
                //console.log(response.data.related_nodes),
                this.links = response.data.related_nodes
            ))
            .catch(function (error) {
                console.log(error);
            });
        },
        pill_isActive: function (node_id, value) {
            if (value < this.links.length) {
                return "up_pill_on"
            }
        },
        comment_class: function (comment) {
            return {
                'has_comment': comment,  
                'empty_comment': !comment
            }
        },
    },
}
</script>

<style scoped>
span.link {
  color: #337ab7;
  cursor: pointer;
  text-decoration: underline;
}
</style>
<style>
.hidden_header {
  display: none;
}
.table-sm td, .table-sm th {
    font-size: 1.25em;
}
.table-sm td, .table-sm th {
    padding: .0rem;
}
.empty_comment {
    color: #ccc;
}
.has_comment {
    color: #41A83F;
}
.up_pill {
    color: white;
    background-color: #9b667a;
    opacity: 0.6;
    margin-bottom: 0.3em;
}
.up_pill_on {
    opacity: 1;
    cursor:pointer;
}
</style>
